<template>
  <div class="offers-tab">
    <div
      v-if="isTenderStatusSummarizing && selectedRows.length"
      class="selected-rows-info"
    >
      <span
        class="selected-rows-info__text"
        @click="onChooseSelectedRows"
      >
        Назначить победителем {{ selectedRows.length }} участников
      </span>
    </div>

    <ObTable
      v-if="currentType === 'byCompanies'"
      :columns="columnsByCompanies"
      :loading="loading"
      :items="filledForms"
      :table-layout-fixed="true"
      :is-functional-sort="false"
      :is-functional-group="false"
      :filter-buttons="filterButtons"
      :functional-panel="true"
      @select="onRowClick"
      @on-change-filter-button="onChangeFilterButton"
      is-fixed-header
    >
      <div
        slot="checkbox"
        slot-scope="{ data }"
      >
        <ObCheckbox
          :disabled="isOfferIsWinner(data.item.participantUuid)"
          v-model="data.item.checked"
          @change="toggleCheck(data.item)"
        />
      </div>

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template
        slot="confirm-button"
        slot-scope="{ data }"
      >
        <div
          v-if="isOfferIsWinner(data.item.participantUuid)"
          class="confirmed-badge"
        >
          <i class="icon checked" /> Выбран победителем
        </div>

        <div
          v-else-if="isTenderStatusSummarizing"
          class="confirm-button"
        >
          <ObButton
            label="Назначить победителем"
            @click="onConfirm(data)"
          />
        </div>
      </template>

      <template slot="noneContent">
        <span class="title">
          Пока здесь нет предложений от участников
        </span>
      </template>
    </ObTable>

    <ObTable
      v-else-if="currentType === 'byQuestions'"
      :columns="columnsByQuestions"
      :loading="loading"
      :items="questionsItems"
      :footer-disabled="true"
      :is-functional-sort="false"
      :is-functional-group="false"
      :filter-buttons="filterButtons"
      :functional-panel="true"
      class="offers-questions-table"
      group-by="group"
      :tableHeight="300"
      @on-change-filter-button="onChangeFilterButton"
    >
      <div
        slot="controls"
        class="controls"
      >
        <ObSwitcher
          v-model="weightlessHidden"
          :value-left="false"
          :value-right="true"
          label-right="Скрывать неоцениваемые вопросы"
          class="controls__weightless"
        />

        <ObSwitcher
          v-model="answersHidden"
          :value-left="false"
          :value-right="true"
          label-right="Скрывать столбцы с ответами"
        />
      </div>

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>

      <template slot="noneContent">
        <span class="title">
          Пока здесь нет предложений от участников
        </span>
      </template>

      <div
        v-for="participantUuid in participantUuids"
        :key="participantUuid"
        :slot="participantUuid"
        slot-scope="{ data }"
        class="answer-container"
      >
        <template v-if="data.item[participantUuid]">
          <div :class="[ 'answer-container__answer', { hidden: answersHidden } ]">
            <button
              v-if="data.item[participantUuid].needModal"
              class="show-answer-button"
              @click="openAnswerModal({
                answer: data.item[participantUuid].answer,
                group: data.item.group,
                participant: data.item[participantUuid].participant,
                question: data.item.question
              })"
            >
              Ответ
            </button>

            <template v-else>
              {{ data.item[participantUuid].answer }}
            </template>
          </div>

          <div :class="[ 'answer-container__scores', { single: answersHidden } ]">
            {{ data.item[participantUuid].weight || '–' }}
          </div>
        </template>

        <template v-else>
          <div class="answer-container__answer">Ответ</div>
          <div class="answer-container__scores">–</div>
        </template>
      </div>
    </ObTable>

    <ObModal
      ref="participant-questionnaire"
      size="extra-large"
      :title="questionnaireTitle"
      :is-show-close-button="true"
    >
      <ParticipantQuestionnaire
        :key="participantUuid"
        :questionnaire-uuid="tender.questionnaireUuid"
        :participant-uuid="participantUuid"
      />
    </ObModal>

    <ObModal
      v-if="modalAnswer"
      ref="participant-answer"
      :title="`Ответ ${modalAnswer.participant}`"
      :is-show-controls="true"
      :is-read-only="true"
      cancel-text="Закрыть"
      size="medium"
    >
      <div class="modal-answer">
        <div class="modal-answer__group">
          {{ modalAnswer.group }}
        </div>
        <div class="modal-answer__question">
          {{ modalAnswer.question }}
        </div>
        <div class="modal-answer__answer">
          <div
            v-for="(answer,idx) in modalAnswer.answer"
            :key="`answer-${idx}`"
            class="modal-answer__answer-item"
          >
            <div
              v-if="answer.title"
              class="modal-answer__answer-title"
            >
              {{ answer.title }}
            </div>
            <div class="modal-answer__answer-value">
              {{ answer.value }}
            </div>
          </div>
        </div>
      </div>
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import api from '@/api'
  import moment from 'moment'

  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObSwitcher from 'common-components/src/obComponents/obSwitcher'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObButton from 'common-components/src/obComponents/obButton'

  import ParticipantQuestionnaire from './modal/participantQuestionnaire'
  import ExportExcel from '../../mixins/export-excel'

  import { mapActions, mapGetters } from 'vuex'

  export default {
    name: 'tender-tab-buyer-offers-rfi',
    mixins: [
      ExportExcel
    ],
    components: {
      ObCheckbox,
      ObModal,
      ObTable,
      ObButton,
      ObSwitcher,
      ParticipantQuestionnaire
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    data() {
      return {
        currentType: 'byCompanies',
        loading: false,
        filledForms: [],
        filledFormsQ: [],
        questionnaireTitle: '',
        participantUuid: '',
        selectedRows: [],
        answersHidden: false,
        weightlessHidden: false,
        modalAnswer: {}
      }
    },
    computed: {
      ...mapGetters({
        winners: 'tenders/winners'
      }),
      columnsByCompanies () {
        return [
          {
            _isEnabled: this.isTenderStatusSummarizing,
            title: '',
            key: 'checkbox',
            slotName: 'checkbox',
            width: 80,
            isToggleDisabled: true,
            sortDisable: true,
            action: true
          },
          {
            title: 'Название контрагента',
            key: 'contractor',
            html: ({ participantTitle }) => participantTitle
          },
          {
            title: 'ИНН',
            key: 'inn',
            html: ({ participantInn }) => participantInn,
            width: 200
          },
          {
            title: 'Всего баллов',
            key: 'scores',
            isAlignRight: true,
            html: ({ countPoints }) => countPoints || '—'
          },
          {
            title: 'Дата и время отправки анкеты, UTC+3',
            key: 'date',
            html: ({ publishedDt }) => moment(publishedDt).locale('ru').format('L, LT')
          },
          {
            title: '',
            slotName: 'confirm-button',
            width: 150,
            isToggleDisabled: true,
            sortDisable: true,
            action: true
          }
        ]
      },
      columnsByQuestions () {
        if (!this.filledFormsQ || !this.filledFormsQ.length) {
          return
        }

        const companies = this.filledFormsQ.map(
          ({ participantUuid, participantTitle }) => (
            {
              _isEnabled: true,
              key: participantUuid,
              slotName: participantUuid,
              title: participantTitle,
              sortDisable: true,
              width: 190
            }
          )
        )

        return [
          {
            key: 'question',
            title: '',
            exactWidth: '310px',
            sortDisable: true,
            fixed: true,
            isToggleDisabled: true,
            html: ({ question, index }) => `${index ? `${index}. ` : ''}${question}`
          },
          ...companies
        ]
      },
      questionsItems () {
        if (!this.filledFormsQ || !this.filledFormsQ.length) {
          return
        }

        let questions = {}

        this.filledFormsQ.forEach((form) => {
          const companyUuid = form.participantUuid
          const companyTitle = form.participantTitle

          form.questionGroups.forEach((group) => {
            const groupTitle = group.title

            group.questions.forEach((question, i) => {
              const questionTitle = question.title

              if (this.weightlessHidden && !question.isEvaluated) {
                return
              }

              if (!questions[question.uuid]) {
                questions[question.uuid] = {
                  index: i + 1,
                  group: groupTitle,
                  question: questionTitle,
                  [companyUuid]: {
                    ...this.getAnswerAndWeight(question),
                    ...this.getAnswer(question),
                    participant: companyTitle
                  }
                }
              } else {
                questions[question.uuid][companyUuid] = {
                  ...this.getAnswerAndWeight(question),
                  ...this.getAnswer(question),
                  participant: companyTitle
                }
              }
            })
          })
        });

        questions = Object.values(questions)

        const scores = { question: 'Итого баллов по участнику:' }

        questions.forEach((questionsItem) => {
          this.participantUuids.forEach((participantUuid) => {
            const weight = Number(questionsItem[participantUuid]?.weight)

            if (!weight) {
              return
            }

            if (!scores[participantUuid]) {
              scores[participantUuid] = { weight }
            } else {
              scores[participantUuid] = { weight: scores[participantUuid].weight += weight }
            }
          })
        })

        return questions.concat([scores])
      },
      filterButtons () {
        return [
          {
            type: 'byCompanies',
            title: 'По компаниям',
          },
          {
            type: 'byQuestions',
            title: 'По вопросам',
          }
        ]
      },
      isTenderStatusSummarizing () {
        return this.tender.status === 'SUMMARIZING'
      },
      participantUuids () {
        return this.filledFormsQ.map(filledForm => filledForm.participantUuid)
      }
    },
    created () {
      this.fetchTablesData()
    },
    methods: {
      ...mapActions({
        getWinners: 'tenders/getWinners'
      }),
      fetchTablesData () {
        this.getFilledFormsByCompanies(this.tender.uuid)
        this.getFilledFormsByQuestions(this.tender.uuid)

        this.getWinners(this.tender.uuid)
      },
      async getFilledFormsByCompanies(uuid) {
        this.loading = true;

        try {
          const { filledForms } = await api.tenders.getRFITenderOffersByCompanies(uuid);

          this.filledForms = filledForms.map((
            {
              participantTitle,
              participantInn,
              participantUuid,
              publishedDt,
              countPoints
            }) => ({
              participantTitle,
              participantInn,
              participantUuid,
              publishedDt,
              countPoints,
              checked: false
            })
          );
        }
        catch (error) {
          console.error(error);

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        } finally {
          this.loading = false;
        }
      },
      async getFilledFormsByQuestions (uuid) {
        const { filledForms } = await api.tenders.getRFITenderOffersByQuestions(uuid);

        this.filledFormsQ = filledForms;
      },
      onChangeFilterButton ({ type }) {
        this.currentType = type
      },
      onRowClick (data) {
        this.participantUuid = data.participantUuid
        this.questionnaireTitle = `Анкета "${data.participantTitle}"`
        this.$refs['participant-questionnaire'].open()
      },
      toggleCheck (item) {
        if (item.checked) {
          this.selectedRows.push(item.participantUuid)
        } else {
          this.selectedRows = this.selectedRows.filter(uuid => uuid !== item.participantUuid)
        }
      },
      async onChooseSelectedRows () {
        try {
          await api.tenders.addParticipantsToTenderSummary(this.tender.uuid, {
            participants: this.selectedRows
          })

          this.$notification({
            type: 'snackbars',
            message: `${this.selectedRows.length} участника назначено победителями`
          })

          this.selectedRows = []

          this.fetchTablesData()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка добавления победителей'
          })
        }
      },
      getAnswerAndWeight (question) {
        if (!question.isEvaluated) {
          return { weight: undefined }
        }

        const fields = question.fields
        let weight = 0

        switch (question.type) {
          case 'MULTISELECT':
            weight = fields
              .filter(field => field.value !== 'false')
              .map(field => field.weight)
              .reduce((acc, cur) => acc + cur)
            break;

          default:
            weight = fields.find(field => field.value === 'true')

            if (weight) {
              weight = weight.weight
            }

            break;
        }

        return { weight }
      },
      getAnswer (question) {
        const needModal = question.type !== 'SELECT'
        const fields = question.fields
        let answer

        switch (question.type) {
          case 'SELECT':
            answer = fields.find(field => field.value === 'true')

            if (answer && answer.title) {
              answer = answer.title
            }
            break;

          case 'MULTISELECT':
            answer = fields
              .filter(field => field.value !== 'false')
              .map(field => field.title)
              .join(', ')
            answer = [{ value: answer }]
            break;

          default:
            if (fields.length === 1) {
              answer = [{ value: fields[0].value }]
            } else {
              answer = fields.map((field) => {
                if (field.type === 'TIME') {
                  field.value = moment(field.value).utc().format('HH:mm')
                } else if (field.type === 'DATE') {
                  field.value = moment(field.value).format('DD.MM.YYYY')
                }

                return {
                  title: field.title,
                  value: field.value,
                  pos: field.pos
                }
              }).sort((a, b) => a.pos - b.pos)
            }
            break;
        }

        return { answer, needModal }
      },
      openAnswerModal (answer) {
        this.modalAnswer = Object.assign(
          {},
          this.modalAnswer,
          answer
        )

        this.$nextTick(() => {
          this.$refs['participant-answer'].open()
        })
      },

      isOfferIsWinner (uuid) {
        if (!this.winners.length) {
          return false
        } else {
          return this.winners.some(winner => winner.participantUuid === uuid)
        }
      },
      async onConfirm (data) {
        try {
          await api.tenders.addParticipantsToTenderSummary(this.tender.uuid, {
            participants: [data.item.participantUuid]
          })

          this.$notification({
            type: 'snackbars',
            message: `Участник назначен победителем`
          })

          this.selectedRows = []

          this.fetchTablesData()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка назначения победителя'
          })
        }
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFIOffers(this.tender.uuid)
      }
    }
  };
</script>

<style lang="scss">
  @import "~common-components/src/static/css/mixins";

  .modal-answer {
    @include font-mixin(14px, 18px, 400, $color-text-base);

    &__group {
      font-weight: 700;
      color: $gray-slate;
    }

    &__question {
      color: $gray-slate;
      margin-bottom: 20px;
    }

    &__answer-item {
      display: flex;
      margin-top: 10px;

      &:first-child {
        margin-top: 0;
      }
    }

    &__answer-title {
      width: 130px;
      color: $color-grey-span;
    }
  }
</style>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .selected-rows-info {
    padding-top: 20px;

    &__text {
      display: inline-block;
      vertical-align: middle;
      line-height: 28px;
      height: 28px;
      margin: 0 20px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }
  }

  .offers-tab {
    height: 100%;
    display: flex; // To prevent height overflow
    flex-direction: column;

    &::v-deep {
      .flex {
        display: flex;
        align-items: center;
      }

      .external-inn-link {
        text-decoration: none;
        font-size: 20px;
        margin-left: 32px;
      }

      .answer-container {
        display: flex;
        text-align: right;

        &__answer {
          margin-right: 25px;
          text-align: right;
          width: 75px;
          color: $color-grey-span;

          &.hidden {
            display: none;
          }
        }

        &__scores:not(.single) {
          width: 40px;
        }
      }

      .controls {
        display: flex;
        align-items: center;
        margin-left: 30px;
        flex-grow: 1;

        &__weightless {
          margin-right: 30px;
        }
      }

      .show-answer-button {
        border: none;
        margin: 0;
        padding: 0;
        width: auto;
        overflow: visible;
        cursor: pointer;
        background: transparent;

        /* inherit font & color from ancestor */
        color: $color-blue-navy-blue;
        font: inherit;

        /* Normalize `line-height`. Cannot be changed from `normal` in Firefox 4+. */
        line-height: normal;

        /* Corrects font smoothing for webkit */
        -webkit-font-smoothing: inherit;
        -moz-osx-font-smoothing: inherit;

        /* Corrects inability to style clickable `input` types in iOS */
        -webkit-appearance: none;
      }


      .confirm-button {
        opacity: 0;
        pointer-events: none;
      }

      tr:hover {
        .scenario-name {
          color: $color-blue-navy-blue;
        }

        .confirm-button {
          opacity: 1;
          pointer-events: all;
        }
      }

      .confirmed-badge {
        @include font-mixin(14px, 18px, 400, $green-craiola);

        display: flex;
        align-items: center;
        justify-content: flex-start;

        i {
          color: $color-green-light;
          font-size: 17px;
          margin-right: 6px;
        }
      }

      .scenario-description {
        color: $color-grey-span;
      }
    }
  }

  .offers-questions-table::v-deep {
    td,
    th {
      &:not(:first-child) {
        border: 1px solid $blue-150;

        & > .td-container {
          justify-content: center;
        }
      }

      &:nth-child(2) {
        border-left: none;
      }
    }

    tbody:nth-last-child(2) {
      &::after {
        position: absolute;
        content: '';
      }
    }

    tbody:last-child {
      tr:first-child {
        display: none;
      }

      tr:last-child {
        td {
          background-color: $background-color-light;

          &.--sticky {
            $color1: $cssTableStyle_gradient_color_1;
            $color2: $cssTableStyle_gradient_color_2;
            $color3: $background-color-light;

            background: linear-gradient(-90deg, $color1 0px, $color2 4px, $color3 4px, $color3 100%);
          }

          & > .td-container {
            @include font-mixin(16px, 20px, bold, $color-text-base, 0.4px);

            border-top: 1px solid $color-grey-span;
          }
        }

        td:first-child > .td-container {
          font-size: 14px;
        }
      }
    }
  }
</style>
